#include "StdAfx.h"
#include "customdlg.h"
#include "resource.h"
#include <stdio.h>
#include "etc.h"

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CCustomDlg::CCustomDlg(void)
: CDlg(IDD_CUSTOM_DLG)
{
	m_iNowEditing = -1;
}

CCustomDlg::~CCustomDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
// _CAOvV[W
BOOL CCustomDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM /*lParam*/)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDC_CSTM_DATE:				// t{^
		case IDC_CSTM_TIME:				// {^
		case IDC_CSTM_YEAR:				// N{^
		case IDC_CSTM_MONTH:			// {^
		case IDC_CSTM_DAY:				// {^
		case IDC_CSTM_HOUR:				// {^
		case IDC_CSTM_MINUTE:			// {^
		case IDC_CSTM_SECOND:			// b{^
		case IDC_CSTM_PROTOCOL:			// vgR{^
		case IDC_CSTM_MYACCOUNT:		// AJEg{^
		case IDC_CSTM_TARGETACCOUNT:	// OAJEg{^
		case IDC_CSTM_FONTNAME:			// tHg{^
		case IDC_CSTM_FONTSIZE:			// tHgTCY{^
		case IDC_CSTM_FONTCOLOR:		// F{^	
		case IDC_CSTM_BACKCOLOR:		// wiF{^
		case IDC_CSTM_STYLE:			// {^
		case IDC_CSTM_FROMACCOUNT:		// M҃AJEg{^
		case IDC_CSTM_FROMNAME:			// MҖ{^
		case IDC_CSTM_MESSAGE:			// bZ[W{{^
		case IDC_CSTM_CSS:				// CSS{^
		case IDC_CSTM_FILENAME:			// t@C{^
		case IDC_CSTM_FILESIZE:			// t@CTCY{^
		case IDC_CSTM_MEMBERLIST:		// Q҃Xg{^
			InsertTag(LOWORD(wParam) - IDC_CSTM_DATE);
			break;

		// ǂݍ݃{^
		case IDC_CSTM_PRESET_BTN:
			OnLoadPresetClick();
			break;

		// bZ[W^CvU^u
		case IDC_CSTM_MSG1:
		case IDC_CSTM_MSG2:
		case IDC_CSTM_MSG3:
		case IDC_CSTM_MSG4:
		case IDC_CSTM_MSG5:
		case IDC_CSTM_MSG6:
			OnFormatSelChanged(LOWORD(wParam) - IDC_CSTM_MSG1);
			break;

		default:
			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

// _CAOJƂ
BOOL CCustomDlg::InitDlgCtrl()
{
	HWND hItemWnd;
	int cid, sid;

	m_iNowEditing = 0;

	// GfBbg{bNX
	hItemWnd = GetDlgItem(IDC_CSTM_FORMAT);
	::SetWindowText(hItemWnd, GetLogFormat(m_iNowEditing));

	// bZ[W^CvWI{^
	SetCheck(IDC_CSTM_MSG1, TRUE);

	// vZbgR{{bNX
	hItemWnd = GetDlgItem(IDC_CSTM_PRESET);
	::SendMessage(hItemWnd, CB_ADDSTRING, 0, (LPARAM)_T("UbZW[݊`"));
	::SendMessage(hItemWnd, CB_ADDSTRING, 0, (LPARAM)_T("eLXg`iʏj"));
	::SendMessage(hItemWnd, CB_ADDSTRING, 0, (LPARAM)_T("eLXg`iڍׁj"));
	::SendMessage(hItemWnd, CB_ADDSTRING, 0, (LPARAM)_T("HTML`"));

	// c[`bv
	m_tip.Create(m_hInstance, m_hDlgWnd);

	cid = IDC_CSTM_DATE;
	sid =IDS_CSTM_DATE;
	for( ; cid <= IDC_CSTM_PRESET_BTN; cid++, sid++ ){
		m_tip.AddToolToToolTip(m_hInstance, m_hDlgWnd, GetDlgItem(cid), sid);
	}
	m_tip.Begin();

	SetVisible(IDC_CSTM_FILENAME, false);
	SetVisible(IDC_CSTM_FILESIZE, false);

	return TRUE;
}

// _CAOƂ
BOOL CCustomDlg::GetDlgCtrlValue()
{
	std::string newFormat;

	// ҏWtH[}bgۑ
	GetItemText(IDC_CSTM_FORMAT, newFormat);
	SetLogFormat(m_iNowEditing, newFormat.c_str());

	return TRUE;
}

//*******************************************************************
// _CAO
//*******************************************************************
// tH[}bgҏWpeLXg{bNXɃ^O}
void CCustomDlg::InsertTag(UINT inTagNo)
{
	HWND hTextWnd;
	LPTSTR tagText;
	int len;

	// ^O
	len = lstrlen(LPF_START_DELIMITER) + lstrlen(LCD_FORMAT[inTagNo]) + lstrlen(LPF_END_DELIMITER);
	tagText = new TCHAR[len+1];
	sprintf_s(tagText, len + 1, LPF_START_DELIMITER "%s" LPF_END_DELIMITER, LCD_FORMAT[inTagNo]);

	// ^O}
	hTextWnd = GetDlgItem(IDC_CSTM_FORMAT);
	::SendMessage(hTextWnd, EM_REPLACESEL, FALSE, (LPARAM)tagText);
	delete tagText;
}

// vZbgǂݍ݃{^ꂽ
void CCustomDlg::OnLoadPresetClick(void)
{
	HWND hCmbWnd = GetDlgItem(IDC_CSTM_PRESET);
	int iSelected = ::SendMessage(hCmbWnd, CB_GETCURSEL, 0, 0);

	if( iSelected != CB_ERR ){
		int ret;

		// mF
		ret = MessageBox(
			m_hDlgWnd,
			_T("SẴOtH[}bgw肳ꂽvZbgŒu܂B"),
			_T("vZbgǂݍ"),
			MB_OKCANCEL|MB_ICONWARNING|MB_APPLMODAL
		);

		if( ret == IDOK ){
			// OtH[}bgu
			for( int i = 0; i < LMT_NUM; i++ )
				SetLogFormat(i, LLF_PRESET[iSelected][i]);

			// GfBbg{bNXXV
			::SetWindowText(GetDlgItem(IDC_CSTM_FORMAT), GetLogFormat(m_iNowEditing));
		}
	}
}

// OtH[}bgIpWI{^ύXꂽ
void CCustomDlg::OnFormatSelChanged(int iSelected)
{
	std::string newFormat;
	bool bVisible;

	// ҏWtH[}bgۑ
	GetItemText(IDC_CSTM_FORMAT, newFormat);
	SetLogFormat(m_iNowEditing, newFormat.c_str());

	// ItH[}bgGfBbg{bNXɕ\
	m_iNowEditing = iSelected;
	::SetWindowText(GetDlgItem(IDC_CSTM_FORMAT), GetLogFormat(m_iNowEditing));

	// ^O}{^̕\ؑ
	bVisible = (iSelected == LMT_MESSAGE);
	SetVisible(IDC_CSTM_FONTNAME, bVisible);
	SetVisible(IDC_CSTM_FONTSIZE, bVisible);
	SetVisible(IDC_CSTM_FONTCOLOR, bVisible);
	SetVisible(IDC_CSTM_BACKCOLOR, bVisible);
	SetVisible(IDC_CSTM_STYLE, bVisible);
	SetVisible(IDC_CSTM_CSS, bVisible);

	SetVisible(IDC_CSTM_FROMACCOUNT,
		(iSelected == LMT_MESSAGE) || (iSelected == LMT_MEMBER_ADD) || (iSelected == LMT_MEMBER_REMOVE));
	SetVisible(IDC_CSTM_FROMNAME,
		(iSelected == LMT_MESSAGE) || (iSelected == LMT_MEMBER_REMOVE));

	SetVisible(IDC_CSTM_MESSAGE,
		bVisible || (iSelected == LMT_FILESESSION_STATUSCHANGE));
	bVisible = (iSelected == LMT_FILESESSION_STATUSCHANGE);
	SetVisible(IDC_CSTM_FILENAME, bVisible);
	SetVisible(IDC_CSTM_FILESIZE, bVisible);
	SetVisible(IDC_CSTM_MEMBERLIST, !((iSelected == LMT_MESSAGE) || bVisible));
}

//*******************************************************************
// ̑
//*******************************************************************
// OtH[}bgZbg
void CCustomDlg::SetLogFormat(int nMsgType, LPCTSTR lpFormat)
{
	m_logFormat[nMsgType] = lpFormat;
}

