#pragma once
#include <string>
#include "dlg.h"
#include "consts.h"

class CCustomDlg: public CDlg
{
public:
	CCustomDlg(void);
	~CCustomDlg(void);

private:
	std::string m_logFormat[LMT_NUM];
	int m_iNowEditing;
	CToolTip m_tip;

	void InsertTag(UINT inTagNo);
	void OnLoadPresetClick(void);
	void OnFormatSelChanged(int iSelected);

// oANZX
public:
	void SetLogFormat(int nMsgType, LPCTSTR lpFormat);
	LPCTSTR GetLogFormat(int nMsgType)
	{
		return m_logFormat[nMsgType].c_str();
	}

// I[o[Ch
private:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();

};
