// Logger.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include "LoggerPlugin.h"
#include "debug.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID /*lpReserved*/
					 )
{
	DEBUG_CODE(static bool bAttached = false);

	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DEBUG_CODE(
			_ASSERT( ! bAttached );
			bAttached = true;
		)
		_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
		CLoggerPlugin::GetInstance().SetModuleInstance((HINSTANCE)hModule);
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

