#include "StdAfx.h"
#include ".\normallogger.h"
#include "LoggerSettings.h"

CNormalLogger::CNormalLogger(const CSessionList *pSessions)
: CLogger(pSessions)
{
	Init();
}

CNormalLogger::~CNormalLogger(void)
{
	Cleanup();
}

// OL^AZbVɎQĂ鎩ȊÕoƂɌĂ΂
//  lpAccount: ZbVɎQĂ郁o1l̃AJEg
//  plmi: L^ׂOɊւ
void CNormalLogger::DoLog(LPCTSTR lpAccount, LogMsgInfo* plmi)
{
	std::string logPath;
	std::wstring logText;

	plmi->plf->GetLogPath(logPath, LOGGER_SETTING.GetBaseDir(), lpAccount, LOGGER_SETTING.GetPathFormat());
	plmi->plf->GetLogText(logText, lpAccount, LOGGER_SETTING.GetLogFormat(plmi->nMsgType));

	try
	{
		WriteLog(logPath.c_str(), logText.c_str());
	}
	catch(LPCTSTR lpErrMsg)
	{
		ErrorMsg(lpErrMsg, plmi->hSessionID);
	}
}

