#pragma once
#include <string>
#include "resource.h"
#include "dlg.h"
#include "LoggerSettings.h"
#include "CustomDlg.h"

class COptionDlg: public CDlg
{
private:
	std::string m_logFormat[LMT_NUM];
	CCustomDlg m_customDlg;
	CToolTip m_tip;

public:
	// RXgN^EfXgN^
	COptionDlg();
	~COptionDlg(void);

private:
	void BrowsDir();
	void ShowCustomDlg();
	void EnableTextOptions(bool bEnable)
	{
		SetEnable(IDC_UNICODE, bEnable);
		SetEnable(IDC_SJIS, bEnable);

		SetEnable(IDC_ESCAPEHTML, bEnable);
		SetEnable(IDC_SESSION, bEnable);
		SetEnable(IDC_SAVE_PER_MSG, bEnable && GetCheck(IDC_SESSION));
	}

// I[o[Ch
private:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();

// _CAOvV[W
private:
	static int CALLBACK BrowsDlgProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
};

