#pragma once
#include <string>
#include "SessionInfo.h"

class CPathFormatter
{
public:
	// RXgN^EfXgN^
	CPathFormatter(void);
	~CPathFormatter(void);

	void Create(const CSessionInfo *si);
	void Create(HNsmConnection hConnectionID);
	void GetLogPath(std::string &out, LPCTSTR lpBaseDir, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const;
	void FormatStr(std::string &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const;

protected:
	std::string m_proto;
	std::string m_myacc;
	SYSTEMTIME m_time;			// 
};
