#pragma once

// vOC
#define PLUGIN_NAME			"Logger"


// Logger 
#define LPF_DEFAULT			_T("<!--Protocol-->\\<!--MyAccount-->\\<!--LogAccount-->\\<!--Year-->-<!--Month-->.txt")

// OZbg
typedef enum tagECharSet{
    LCS_UNICODE,
	LCS_LOCALE
} ECharSet;

enum LoggerType{
	LLT_MSN,
	LLT_NOSEP,
	LLT_SEP_SES,
	LLT_SEP_MSG,
};

// OtH[}bg
typedef enum tagEFormatType{
	LFT_NISE,
	LFT_TEXT,
	LFT_TEXTPLUS,
	LFT_HTML,
	LFT_MSN,
	LFT_CUSTOM,
	LFT_NUM,
} EFormatType;

// bZ[W
typedef enum tagEMsgType{
	LMT_MESSAGE=0,
	LMT_SESSION_OPEN,
	LMT_SESSION_CLOSE,
	LMT_MEMBER_ADD,
	LMT_MEMBER_REMOVE,
	LMT_FILESESSION_STATUSCHANGE,
	LMT_NUM
} EMsgType;

#define LMT_SYSMESSAGE	LMT_NUM

// GetInfõobt@TCY
#define COLOR_STR_LEN		6
#define INFOBUF_LEN			1024
#define ITOT_BUF_LEN		35

// Logger Logging Once
#define LLO_LOGACCOUNT		""

// Logger Font Style String
#define LSTR_NULL			L""
#define LFSS_NONE			L"Ȃ"
#define LFSS_BOLD			L" "
#define LFSS_ITALIC			L"Α "
#define LFSS_UNDERLINE		L" "
#define LFSS_STRIKEOUT		L" "

// Logger Font Style
#define LFS_BOLD			2        // 
#define LFS_ITALIC			4        // Α
#define LFS_UNDERLINE		8        // 
#define LFS_STRIKEOUT		16       // 

// Logger Log Format
#define LLF_MEMBER_ADD		L"bɎQ܂B"
#define LLF_MEMBER_REMOVE	L"bސȂ܂B"

#define FONTSIZE_UNAVAILABLE	L"ݒȂ"

// Logger Path Formatter
#define LPF_START_DELIMITER	"<!--"
#define LPF_END_DELIMITER	"-->"
#define LPF_DATE			"Date"
#define LPF_TIME			"Time"
#define LPF_YEAR			"Year"
#define LPF_MONTH			"Month"
#define LPF_DAY				"Day"
#define LPF_HOUR			"Hour"
#define LPF_MINUTE			"Minute"
#define LPF_SECOND			"Second"
#define LPF_PROTOCOL		"Protocol"
#define LPF_MYACCOUNT		"MyAccount"
#define LPF_TARGETACCOUNT	"LogAccount"

#define LPF_FONTNAME		"FontName"
#define LPF_FONTSIZE		"FontSize"
#define LPF_FONTCOLOR		"FontColor"
#define LPF_BACKCOLOR		"BackColor"
#define LPF_STYLE			"Style"
#define LPF_FROMACCOUNT		"FromAccount"
#define LPF_FROMNAME		"FromName"
#define LPF_MESSAGE			"Message"
#define LPF_CSS				"CSS"
#define LPF_FILENAME		"FileName"
#define LPF_FILESIZE		"FileSize"
#define LPF_MEMBERLIST		"MemberList"
#define LPF_CONNECTIONID	"ConnectionID"

// Logger Log Formatter
#define LLF_START_DELIMITER	L"<!--"
#define LLF_END_DELIMITER	L"-->"
#define LLF_FONTNAME		L"FontName"
#define LLF_FONTSIZE		L"FontSize"
#define LLF_FONTCOLOR		L"FontColor"
#define LLF_BACKCOLOR		L"BackColor"
#define LLF_STYLE			L"Style"
#define LLF_FROMACCOUNT		L"FromAccount"
#define LLF_FROMNAME		L"FromName"
#define LLF_MESSAGE			L"Message"
#define LLF_CSS				L"CSS"
#define LLF_FILENAME		L"FileName"
#define LLF_FILESIZE		L"FileSize"
#define LLF_MEMBERLIST		L"MemberList"

#define LLF_ML_FORMAT		L"%s [%S]"

// Logger XML Log Formatter
#define LXF_DATETIME		L"DateTimeUTC"
#define LXF_SESSIONID		L"SessionID"
#define LXF_TOLIST			L"ToList"
#define LXF_RESPONCE		L"Responce"
#define LXF_USERFORMAT		L"<User LogonName=\"%S\" FriendlyName=\"%s\"/>"

#define LXS_XSL_FILE		"MessageLog.xsl"

// Logger System Format
#define LSF_COMMON			"[<!--Date--> <!--Time-->] <!--Protocol-->(<!--ConnectionID-->:<!--MyAccount-->) "
#define LSF_CONNECT			"ڑ\n"
#define LSF_DISCONNECT		"ؒf\n"
#define LSF_CINFO			L"%SRlNVύX %su%svɕύX\n"
#define LSF_MINFO			L"%SoύX u%sv(%S)%su%svɕύX\n"

// Logger Error Message
#define LEM_CANT_OPEN_FILE	"t@CJ܂"
#define LEM_SEEK_MISS		"V[NɎs܂"
#define LEM_CANT_WRITE		"݂Ɏs܂"
#define LEM_CANT_MAKE_DIR	"tH_̍쐬Ɏs܂"
#define LEM_CANT_CONVERT	"UnicodeShift_JISւ̕ϊɎs܂"
#define LEM_CHARSET_ERR		"ZbgG["
#define LEM_CANT_GET_FSIZE	"t@CTCY̎擾Ɏs܂"

#define LEM_CANT_DELETE "Ot@C̍폜Ɏs܂"
#define LEM_CANT_RENAME	"Ot@C̍XVɎs܂"
#define LEM_CANT_READ	"Ot@C̓ǂݍ݂Ɏs܂"

