#pragma once
#include "logformatter.h"

class CXMLLogFormatter :
	public CLogFormatter
{
private:
	std::wstring m_myName;

public:
	// RXgN^EfXgN^
	CXMLLogFormatter(void);
	~CXMLLogFormatter(void);

	// I[o[horI[o[Ch
	void GetLogText(std::wstring &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const;
	void Create(const CSessionInfo *si, PMessageInfo pMsgInfo, HNsmFileSession hFileSession=NULL);
	void Create(const CSessionInfo *si, LPCSTR lpFrom, HNsmFileSession hFileSession=0);
	void FormatStr(std::wstring &out, LPCWSTR lpFormat) const;
};
